#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<time.h>
#define _FILE_OFFSET_BITS 64

int GetRand(int min,int max)
	{
	int rdtsc()
	{
       	__asm__ __volatile__("rdtsc");
	}
	int n;
	srand(rdtsc());
	n = (rand() % (max - min + 1) + min);
	return(n);
	}

void nombre_elmt_par_ln(FILE *entree0,int *nb_var0)
	{
	char c;
	int in_chaine = 0;
	while(1)	
		{
		c = fgetc(entree0);
		if(c == '\n') break;	
		if((in_chaine == 0) && ((c!='\t') && (c!=' ')))
			{
			*nb_var0 = *nb_var0 + 1;
			in_chaine = 1;
			}
		if((c == '\t') || (c == ' ')) 
			in_chaine = 0;
		else 
			in_chaine = 1;
		
		}
	rewind(entree0);
	} 

void nb_lines(FILE *entree0,int *nb_ln0, int tit)
{
        char c;
	if(tit == 1)
		do c = fgetc(entree0); while(c != '\n');
        while(1)
        	{
        	do c = fgetc(entree0);
        	while(c!='\n' && !feof(entree0));
        	if(feof(entree0)) break;
        	*nb_ln0 = *nb_ln0 + 1;
        	}
	rewind(entree0);
}


main(int argc, char **argv)
{

FILE *GIGI, *BEAGLE, *RSQR, *PAR, *OUT_PROB, *OUT_DOSE;

if(argc !=7 ){
printf("Normal usage: ./PED_POP  <GIGI.prob> <population-based imputation.prob> <RSQR> <ParameterFile> <OUT_PROB> <OUT_DOSE>\n");
exit(1);
}

if(!(GIGI=fopen(argv[1],"r")))
puts("Error GIGI Input File\n");

if(!(BEAGLE=fopen(argv[2],"r")))
puts("Error BEAGLE Input File\n");

if(!(RSQR=fopen(argv[3],"r")))
puts("Error R-square Input File\n");

if(!(PAR=fopen(argv[4],"r")))
puts("Error Parameters Input File\n");

if(!(OUT_PROB=fopen(argv[5],"w")))
puts("Error opening OutProb file\n");

if(!(OUT_DOSE=fopen(argv[6],"w")))
puts("Error opening OutDose file\n");

// Count the number of columns and lines per each file and check if they are equal! 
int nb_var_g = 0;   // #Col of GIGI
int nb_snp = 0;     // #SNPs
int nb_ln_g = 0;   // #Lines of GIGI
nb_lines(GIGI,&nb_ln_g,0);
nombre_elmt_par_ln(GIGI,&nb_var_g);

int nb_var_b = 0;   // #Col of BEAGLE
int nb_ln_b = 0;   // #Lines of BEAGLE
nb_lines(BEAGLE,&nb_ln_b,0);
nombre_elmt_par_ln(BEAGLE,&nb_var_b);
nb_snp = nb_var_g/3 ; 

int nb_var_r = 0;   // #Col of RSQ file
int nb_ln_r = 0;   // #Lines of RSQ file
nb_lines(RSQR,&nb_ln_r,0);
nombre_elmt_par_ln(RSQR,&nb_var_r);

printf("#Lines and #Cols of family-based approach %d %d \n",  nb_ln_g, nb_var_g) ;
printf("#Lines and #Cols of population-based approach %d %d \n",  nb_ln_b, nb_var_b) ;
printf("#SNPs %d \n", nb_snp);
if (nb_var_g != nb_var_b || nb_ln_g != nb_ln_b) {puts("Inconsistency in Column/Line numbers. Check your files!"); exit(1);}
/////////////////////////////////////////////////////////////////////////////////

int i,j,k,l =0 ;
float prob,R, maf =0;
char snp[50];
char method[50];
char name[50];
// Allocate memory for the two prob files (GIGI and BEAGLE) and frequency file of GIGI:
float **PROB_G;
PROB_G = (float**)malloc(nb_ln_g*sizeof(float*));
for(j=0;j<nb_ln_g;j++)
PROB_G[j] =(float*)malloc(nb_var_g*sizeof(float));

float **PROB_B;
PROB_B = (float**)malloc(nb_ln_b*sizeof(float*));
for(j=0;j<nb_ln_b;j++)
PROB_B[j] =(float*)malloc(nb_var_b*sizeof(float));

float *FREQ_G;
FREQ_G = (float*)malloc(nb_snp*sizeof(float));

float *FREQ_B;
FREQ_B = (float*)malloc(nb_snp*sizeof(float));

float *RSQ;
RSQ = (float*)malloc(nb_snp*sizeof(float));

for (i=0;i<nb_ln_g;i++)
{
for (j=0;j<nb_var_g;j++)
{
PROB_G[i][j]=0;
PROB_B[i][j]=0;
}
}

// Read RSQR File
for (i=0; i<nb_snp;i++)
{
fscanf(RSQR , "%s %f", &snp , &R) ;
RSQ[i] = R ;
}

// Read the PAR file
fscanf(PAR , " %s %f " , &name, &maf) ;
fscanf(PAR , " %s %s " , &name, &method) ;
printf("Your method and your maf are: %s %.3f \n", method, maf);

// Read both GIGI and population-based approache probalitie files:
for (i=0; i<nb_ln_g;i++)
{
	for (j=0;j<nb_var_g;j++)
	{
	fscanf(GIGI," %f ", &prob);
	PROB_G[i][j] = prob;
	fscanf(BEAGLE," %f ", &prob);
	PROB_B[i][j] = prob;
	}
}

// Estimate the allele frequencies in both datasets
float Sum1=0;
float Sum2=0;
for (i=0; i<nb_snp;i++)
{
Sum1=0 ; Sum2=0;
	for (j=0; j<nb_ln_g;j++)
	{
	if (PROB_G[j][i*3] != 99)
	{
	Sum1 = Sum1 + 2*PROB_G[j][i*3] + PROB_G[j][i*3+1] ;
	}
	if (PROB_B[j][i*3] != 99)
	{
	Sum2 = Sum2 + 2*PROB_B[j][i*3] + PROB_B[j][i*3+1] ;
	}
	}
FREQ_G[i] =(float) Sum1/(2*nb_ln_g);
FREQ_B[i] =(float) Sum2/(2*nb_ln_g);
Sum1=0 ; Sum2=0;
}

// Code toward the minor alleles
float temp=0;
for (i=0; i<nb_snp;i++)
{
        if (FREQ_G[i]>0.5)
        {
                for (j=0; j<nb_ln_g;j++)
                {
		temp = PROB_G[j][i*3];
		PROB_G[j][i*3] = PROB_G[j][i*3+2];
		PROB_G[j][i*3+2] = temp; 
                }
        }
        if (FREQ_B[i]>0.5)
        {
                for (j=0; j<nb_ln_g;j++)
                {
		temp = PROB_B[j][i*3];
		PROB_B[j][i*3] = PROB_B[j][i*3+2];
		PROB_B[j][i*3+2] = temp; 
                }
        }
}

for (i=0; i<nb_snp;i++)
{
Sum1=0 ; Sum2=0;
	for (j=0; j<nb_ln_g;j++)
	{
	if (PROB_G[j][i*3] != 99)
	{
	Sum1 = Sum1 + 2*PROB_G[j][i*3] + PROB_G[j][i*3+1] ;
	}
	if (PROB_B[j][i*3] != 99)
	{
	Sum2 = Sum2 + 2*PROB_B[j][i*3] + PROB_B[j][i*3+1] ;
	}
	}
FREQ_G[i] =(float) Sum1/(2*nb_ln_g);
FREQ_B[i] =(float) Sum2/(2*nb_ln_g);
Sum1=0 ; Sum2=0;
}

char ped_pop[20];
char ped_pop_thresh[20] ;
ped_pop[0] = 'P' ; ped_pop[1] = 'E' ; ped_pop[2] = 'D' ; ped_pop[3] = '_' ; ped_pop[4] = 'P' ; ped_pop[5] = 'O' ; ped_pop[6] = 'P' ;ped_pop[7] = '\0' ;
ped_pop_thresh[0] = 'P' ; ped_pop_thresh[1] = 'E' ; ped_pop_thresh[2] = 'D' ; ped_pop_thresh[3] = '_' ; ped_pop_thresh[4] = 'P' ; ped_pop_thresh[5] = 'O' ; ped_pop_thresh[6] = 'P' ; ped_pop_thresh[7] = '_' ;ped_pop_thresh[8] = 't' ; ped_pop_thresh[9] = 'h' ; ped_pop_thresh[10] = 'r' ; ped_pop_thresh[11] = 'e' ; ped_pop_thresh[12] = 's' ; ped_pop_thresh[13] = 'h'; ped_pop_thresh[14]='\0';
float x2_b,x2_g,var_b,var_g,dose =0;

// This section is a threshold-base combining:
if (strcmp(method,ped_pop_thresh)==0) //// To indicate the method:
{ 
for (i=0; i<nb_ln_g;i++)
{
	for (j=0;j<nb_snp;j++)
	{
		if (FREQ_G[j]>maf) 
		{
			if (PROB_B[i][j*3]!=99)
			{
			fprintf(OUT_PROB , "%.3f %.3f %.3f ", PROB_B[i][j*3], PROB_B[i][j*3+1], PROB_B[i][j*3+2]) ; 
			fprintf(OUT_DOSE , "%.3f ", 2*PROB_B[i][j*3]+PROB_B[i][j*3+1]) ; 
			}else
			{
			if (PROB_G[i][j*3]!=99)
			{
			fprintf(OUT_PROB , "%.3f %.3f %.3f ", PROB_G[i][j*3], PROB_G[i][j*3+1], PROB_G[i][j*3+2]) ; 
			fprintf(OUT_DOSE , "%.3f ", 2*PROB_G[i][j*3]+PROB_G[i][j*3+1]) ; 
			} else
			{
			fprintf(OUT_PROB , "99 99 99 ") ; 
			fprintf(OUT_DOSE , "99 ") ; 
			}
			}
		}else
		{
			if (PROB_G[i][j*3]!=99)
			{
			fprintf(OUT_PROB , "%.3f %.3f %.3f ", PROB_G[i][j*3], PROB_G[i][j*3+1], PROB_G[i][j*3+2]) ; 
			fprintf(OUT_DOSE , "%.3f ", 2*PROB_G[i][j*3]+PROB_G[i][j*3+1]) ; 
			}else{
			if (PROB_B[i][j*3]!=99)
			{
			fprintf(OUT_PROB , "%.3f %.3f %.3f ", PROB_B[i][j*3], PROB_B[i][j*3+1], PROB_B[i][j*3+2]) ; 
			fprintf(OUT_DOSE , "%.3f ", 2*PROB_B[i][j*3]+PROB_B[i][j*3+1]) ; 
			} else{
			fprintf(OUT_PROB , "99 99 99 ") ; 
			fprintf(OUT_DOSE , "99 ") ; 
			}
		}
		}
	}
	fprintf(OUT_PROB , "\n") ; 
	fprintf(OUT_DOSE , "\n") ; 
	}
}
// This section is the variance-based combining approache:
float prob0,prob1, prob2 =0;
if (strcmp(method,ped_pop)==0) //// To indicate the method:
{ 
if (nb_ln_r != nb_snp) {puts("RSQR file has less/more SNPs than should be. Check your files!"); exit(1);}
for (i=0; i<nb_ln_g;i++)
{
	for (j=0;j<nb_snp;j++)
	{
	var_b=0; var_g=0; x2_g=0; x2_b =0;
		x2_b = (PROB_B[i][j*3] -(float)1/3)*(PROB_B[i][j*3]-(float)1/3)+ (PROB_B[i][j*3+1] -(float)1/3)*(PROB_B[i][j*3+1]-(float)1/3) + (PROB_B[i][j*3+2] -(float)1/3)*(PROB_B[i][j*3+2]-(float)1/3)  ;
		x2_g = (PROB_G[i][j*3] -(float)1/3)*(PROB_G[i][j*3]-(float)1/3)+ (PROB_G[i][j*3+1] -(float)1/3)*(PROB_G[i][j*3+1]-(float)1/3) + (PROB_G[i][j*3+2] -(float)1/3)*(PROB_G[i][j*3+2]-(float)1/3)  ;
	if (FREQ_G[j]<=maf)
	{
	var_b = (float) (RSQ[j]*x2_b)/2; 
	}else
	{
	var_b = (float) (x2_b)/2; 
	}
	var_g = (float)x2_g/2; 
	//printf("%f %f", var_b, var_g);
	if (var_b>var_g)
	{
	fprintf(OUT_PROB, "%.4f %.4f %.4f ", PROB_B[i][j*3], PROB_B[i][j*3+1], PROB_B[i][j*3+2]) ;
	fprintf(OUT_DOSE, "%.4f ", 2*PROB_B[i][j*3] +  PROB_B[i][j*3+1]) ;
	}else
	{
	fprintf(OUT_PROB, "%.4f %.4f %.4f ", PROB_G[i][j*3], PROB_G[i][j*3+1], PROB_G[i][j*3+2]) ;
	fprintf(OUT_DOSE, "%.4f ", 2*PROB_G[i][j*3] +  PROB_G[i][j*3+1]) ;
	}
	}
	fprintf(OUT_PROB , "\n") ; 
	fprintf(OUT_DOSE , "\n") ; 
}
}

///////////////////////////////////////////////////////
fclose(GIGI);
fclose(BEAGLE);
fclose(RSQR);
fclose(OUT_PROB);
fclose(OUT_DOSE);
return 0;
}

